#! /usr/bin/bash

$(/opt/lampp/bin/mysql -u root -e "create database cryptoTracker; use cryptoTracker")

#To store different types of crypto
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker; create table crypto (cryptoId int PRIMARY KEY, name varchar(20))")
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker; insert into crypto values (1,'Bitcoin')")


#To store the crypto price (value)
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker; 
create table cryptoPrice (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")

#To store the 24 Hour Low 
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table lowPrice (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")

#To store the 24 Hour High 
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table highPrice (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")


#To store the 24 Hour Open 
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table openPrice (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")



#To store the Market Cap
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table marketCap (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")


#To store the Change In Value
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table changeInValue (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")



#To store the Return Percentage
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table returnPercentage (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")


#To store the Volatility
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table volatility (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")



#To store the Transaction Count
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table transactionCount (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")


#To store the Transaction Fee
$(/opt/lampp/bin/mysql -u root -e "use cryptoTracker;
create table transactionFee (
id int AUTO_INCREMENT,
cryptoID int,
value float,
collected datetime,
PRIMARY KEY(id),
FOREIGN KEY(cryptoID) REFERENCES crypto(cryptoId)
)")
